/** Array3.java
 *  The intention of this program is to make a copy of an existing ArrayList object with the
 *  assignment operator.  However, this program demonstrates an "aliasing" problem with two ArrayList objects.
 *  The aList2 object is assigned to aList1, which results in two objects sharing the
 *  same reference.  When a change is made to aList2, it also creates an identical
 *  and possible unwanted change, in aList1.
 *  By Jane Chapman, Michael Landrum and Leon Schram
 */ 

import java.util.ArrayList;  //Includes the ArrayList class of the util package.
 
public class Array3
{
	public static void main (String [] arg)
	{
		System.out.println("\nArray Demo 3 \n");
		ArrayList aList1 = new ArrayList();   	//Instantiation of an ArrayList object (no elements)
		aList1.add("Leon");
		aList1.add("Jane");
		aList1.add("Mike");
		
		ArrayList aList2 = new ArrayList();   	//Instantiation of an ArrayList object (no elements)
		
		aList2 = aList1;						// erroneous copy attempt, results in aliasing
		System.out.print("aList1 contains:");		
		listForward(aList1);
		System.out.print("aList2 contains:");
		listForward(aList2);
		
		aList2.set(0,"Richard");				// one array element in aList2 is intentionally altered
		
		System.out.print("\naList1 contains:");		
		listForward(aList1);
		System.out.print("aList2 contains:");
		listForward(aList2);
		System.out.println();		
	}
	
	
	public static void listForward(ArrayList tList)
	{   
	    for (int x = 0; x < tList.size() ; x++)
	    {
	    	System.out.print("   "+ tList.get(x) + "   ");
	    }
	    System.out.println();		
	}	
		
}
		
		