import java.util.*;

/*
 program: ARRAY8
 Find all unbroken sequences of composite numbers 40 or more numbers
 in length in the first 30,000 integers.
 .rfrank 03-Jan-2002
 */

class Array8
{
  public static void main(String[] args)
  {
  	 System.out.println("Array 8\n");
    final int MIN_LEN = 40;
    final int TOP = 30000;
    ArrayList c = new ArrayList();
    for (int i=1; i<TOP; i++)
    {
        if ( !isPrime(i) )
        {
            // save it
            c.add(new Integer(i));
            if ( c.size() >= MIN_LEN && isPrime(i+1) )
                {
                    System.out.println("Sequence of " +c.size() + ": ");
                    Iterator cIterator = c.iterator();
                    while ( cIterator.hasNext() )
                        System.out.print( (Integer)cIterator.next() + " " ); 
                    System.out.print("\n\n");
                }
        }
        else
        {
            // clear it
            c = new ArrayList();
        }
    }
  }
   
  /*
   trivial function returns true if n is prime
   */
  static boolean isPrime(int n)
  {
    int TOP = (int)(Math.sqrt(n)) + 1;
    for (int i=2; i<TOP; i++)
      if (n % i == 0)
        return false;
    return true;
  }
}
