public class HourlyEmployee extends Employee
{
	private double hourlyRate;
	private double hoursWorked;

	//precondition:  nm is in the form Last, First
	public HourlyEmployee(String nm, String empID,
					      double rate)
	{
		super(nm,empID);
		hourlyRate = rate;
		hoursWorked = 0;	
	}	
	
	//The hours for the current pay period must be set
	//before calling getPaycheck
	public void setHoursWorked(double hours)
	{
		hoursWorked = hours;
	}
	
	public double getHoursWorked()
	{
		return hoursWorked;
	}
	
	public void raisePay(double amount)
	{
		hourlyRate += amount;
	}
	
	//returns the amount of weekly pay an employee
	//will receive, given the number of hours worked
	//must call setWeeklyHours for the week before
	//calling this method.
	public double getPayCheck()
	{
		double ot = hoursWorked - 40;
		if(ot > 0)
		   return ot * 1.5 *hourlyRate + 40 * hourlyRate;
		else
		   return hoursWorked * hourlyRate;	
	}
	
	public double getHourlyRate()
	{
		return hourlyRate;
	}
	
	public String toString()
	{
		return super.toString() + "\nPay Rate: " + hourlyRate 
		       + "\nCurrent Paycheck: " + getPayCheck();
	}			     	
}