import java.util.*;
public class Payroll2
{
	private ArrayList hourlyEmp; //TreeMap for Hourly Employees - key is name
	private ArrayList salariedEmp; //TreeMap for Salaried Employees - key is name
	private ArrayList allEmp;  //HashMap for all employees - key is id
	
	public Payroll2()
	{
		hourlyEmp = new ArrayList();
		salariedEmp = new ArrayList ();
		allEmp = new ArrayList ();
	}
	
	//emp has been added to hourlyEmp and allEmp
	public void addEmp(HourlyEmployee emp)
	{
		hourlyEmp.add(emp);
		allEmp.add(emp);	
	}	

	//emp has been added to salariedEmp and allEmp
	public void addEmp(SalariedEmployee emp)
	{
		salariedEmp.add(emp);
		allEmp.add(emp);	
	}
	

	private int find(String id)
	{
		for(int j = 0; j < allEmp.size(); j++)
		{
			Employee emp = (Employee) allEmp.get(j);
			if(emp.getID().equals(id))
                        return j;
		}
		return -1;
	}
	
 
	//precondition: if an employee with id employee id
	//exists, that employee is either in hourlyEmp or
	//salariedEmp, not both.
	public void removeEmp(String id)
	{
		int index = find(id);
		if(index != -1)
		{
			Employee emp = (Employee) allEmp.remove(find(id));
			if(!hourlyEmp.remove(emp))
			    salariedEmp.remove(emp);
		}
	}

	//precondition:  t holds all the timecards for all hourly
	//employees.
	//postcondition:  all hourly employees' weekly hours
	//worked has been updated
	public void updateWeeklyHours(TimeCards t)
	{
		for(int j = 0; j < hourlyEmp.size(); j++)
		{
			HourlyEmployee emp = (HourlyEmployee) hourlyEmp.get(j);
			emp.setHoursWorked(t.getHoursWorked(emp.getID()));
		}
	}
	
	//returns the total amount of all employee's paychecks
	public double getTotalPayroll()
	{
	
		double total = 0;
		for(int j = 0; j < allEmp.size(); j++)
		{
			Employee emp = (Employee)allEmp.get(j);
			total += emp.getPayCheck();
		}
		return total;	
	}
	
	public Employee getEmployee(String id)
	{
		int index = find(id);
		if(index != -1)
			return (Employee) allEmp.get(index);
		else
			return null;
	}
	
	public void printHourlyEmployees()
	{
		print(hourlyEmp,"Hourly");
	}
	
	public void printSalariedEmployees()
	{
		print(salariedEmp, "Salaried");
	}
	
	private void print(ArrayList list, String type)
	{
		
		System.out.println("=====================================================");		
		System.out.println("Listing of all " + type + " Employees");
		for(int j = 0; j < list.size(); j++)
		{
			System.out.println(list.get(j) + "\n");
		}	
		System.out.println("=====================================================\n");		
		
	}			
}
