import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import java.util.ArrayList;
import java.awt.Container;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.*;


/**
   This frame contains a panel that displays a rectangle
   and a panel of text fields to specify the rectangle position.
   Used with Picker class in Lottery game, Fran Trees
*/
public class RectangleFrame extends JFrame
{
   private RectanglePanel rectPanel;
   private ArrayList balls = new ArrayList();
   private ArrayList graphicBalls = new ArrayList();
   private Picker ballPicker = new Picker(54);
   private int count = 0;
   private int x = 5;
   private static JButton lottoButton = new JButton("Pick Ball");
   
   
   
   /**
      Constructs the frame.
   */
   public RectangleFrame()
   {
      // the panel that draws the rectangle
      rectPanel = new RectanglePanel();
      setTitle("NJ Lottery- Pick 6");

      // add panel to content Pane
      getContentPane().add(rectPanel, BorderLayout.CENTER);

      createControlPanel();

      pack();
   }

   /**
      Creates the control panel with the text fields
      at the bottom of the frame.
   */
   private void createControlPanel()
   {

      // the button to move the rectangle


      class LottoButtonListener implements ActionListener
      {
         public void actionPerformed(ActionEvent event)
         {
            if(count < 6)
            {
             balls.add(ballPicker.chooseBall());
             graphicBalls.add(new Ellipse2D.Double(x + count * 50, 100, 40,40));
             count++;
            }
            else
            {
               lottoButton.setText("Done!");
            }
            rectPanel.setBalls(graphicBalls,balls);
         }
      }

      ActionListener listener = new LottoButtonListener();
      lottoButton.addActionListener(listener);

      // the panel for holding the user interface components
      JPanel controlPanel = new JPanel();
      controlPanel.add(lottoButton);

      getContentPane().add(controlPanel, BorderLayout.SOUTH);
   }


}





